/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.brick;

import org.fortiss.af3.component.model.InputPort;
import org.fortiss.af3.platform.language.executable.ExecutableBase;
import org.fortiss.af3.platform.raspberry.generator.executable.framework.IInstanceInitializationExecutable;
import org.fortiss.af3.platform.raspberry.generator.executable.framework.IReadableExecutable;
import org.fortiss.af3.platform.raspberry.model.brick.UltraSonicSensor;

/**
 * {@link ExecutableBase} for {@link UltraSonicSensor}s.
 * 
 * @author hoelzl
 */
public class UltraSonicSensorExecutable extends BrickExecutableBase<UltraSonicSensor> implements
		IReadableExecutable, IInstanceInitializationExecutable {
	/** Constructor. */
	public UltraSonicSensorExecutable(UltraSonicSensor modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	@Override
	public String getHeaderFileName() {
		return "bricklet_distance_us.h";
	}

	/** {@inheritDoc} */
	@Override
	public String getVariableDeclaration(String postfix, String singletonPostfix) {
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public String getInitializationCode(String postfix, String singletonPostfix) {
		// TODO Auto-generated method stub
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public String getReadCode(String prefix, String singletonPrefix, InputPort logicalSignal,
			String targetVariable) {
		// sb.append("DistanceUS DistanceUS_A;\n");
		// sb.append("uid_us_A = \"" + sensor.getUniqueBrickletID() + "\";\n");
		// sb.append("distance_us_create(&DistanceUS_A, \"" +
		// sensor.getUniqueBrickletID() + "\", &brick_connection);\n");
		// sb.append("distance_us_register_callback(&DistanceUS_A, DISTANCE_US_CALLBACK_DISTANCE, (void*)us_A_callback, NULL);\n");
		// sb.append("distance_us_set_distance_callback_period(&DistanceUS_A, 10);\n");
		return null;
	}

	/** {@inheritDoc} */
	@Override
	public String getNoValReadCode(String prefix, String singletonPrefix, InputPort logicalSignal) {
		return null;
	}
}
