/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.framework;

import org.fortiss.af3.platform.language.executable.ExecutableBase;

/**
 * Interface for {@link ExecutableBase}s, which require to be terminated during program shutdown.
 * The termination code is included for every executable instance with the {@code postfix} provided
 * by the code generator.
 * 
 * @author hoelzl
 */
public interface IInstanceTerminationExecutable extends IInstanceExecutable {
	/** Returns an termination code for the given {@code postfix}. */
	String getInstanceTerminationCode(String postfix);
}
