/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.framework;

import org.fortiss.af3.component.model.OutputPort;

/**
 * Executable for platform elements that can be written (e.g. actuators and busses).
 * 
 * @author hoelzl
 */
public interface IWriteableExecutable {
	/** Returns the write code for the given port. */
	String getWriteCode(String postfix, String singletonPostfix, OutputPort logicalSignal,
			String value);

	/**
	 * Returns the write code for the given port if the value to be written is NoVal. May return
	 * {@code null}, to indicate that NoVal is not supported.
	 */
	String getNoValWriteCode(String postfix, String singletonPostfix, OutputPort logicalSignal);
}
